1、创建命令生成器模块,实现部分命令数据生成,还需继续实现其他命令;
2、完善代码。
2个文件已修改
19个文件已添加
1475 ■■■■■ 已修改文件
pipIrr-platform/pipIrr-common/src/main/java/com/dy/common/mw/protocol/p206V1/parse/Cd_10_Down.java 2 ●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/.gitattributes 2 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/.gitignore 33 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/.mvn/wrapper/maven-wrapper.properties 19 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/mvnw 259 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/mvnw.cmd 149 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/pom.xml 175 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/PipIrrComCreatorApplication.java 166 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/Server.java 27 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/ServerProperties.java 16 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/console/Command.java 185 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/console/CommandConsole.java 89 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd.java 65 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd02.java 51 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd10.java 64 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd92.java 59 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd93.java 59 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/resources/application.yml 18 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/resources/log4j2.xml 23 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/test/java/com/dy/pipirrComCreator/PipIrrComCreatorApplicationTests.java 13 ●●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-mw/pom.xml 1 ●●●● 补丁 | 查看 | 原始文档 | blame | 历史
pipIrr-platform/pipIrr-common/src/main/java/com/dy/common/mw/protocol/p206V1/parse/Cd_10_Down.java
@@ -66,7 +66,7 @@
                throw new Exception("json转Com10Vo为null");
            }
            if (cvo.rtuAddr == null) {
                throw new Exception("测试新地址不能为空");
                throw new Exception("地址不能为空");
            }
            CommonV1 commonV_1 = new CommonV1();
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/.gitattributes
New file
@@ -0,0 +1,2 @@
/mvnw text eol=lf
*.cmd text eol=crlf
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/.gitignore
New file
@@ -0,0 +1,33 @@
HELP.md
target/
!.mvn/wrapper/maven-wrapper.jar
!**/src/main/**/target/
!**/src/test/**/target/
### STS ###
.apt_generated
.classpath
.factorypath
.project
.settings
.springBeans
.sts4-cache
### IntelliJ IDEA ###
.idea
*.iws
*.iml
*.ipr
### NetBeans ###
/nbproject/private/
/nbbuild/
/dist/
/nbdist/
/.nb-gradle/
build/
!**/src/main/**/build/
!**/src/test/**/build/
### VS Code ###
.vscode/
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/.mvn/wrapper/maven-wrapper.properties
New file
@@ -0,0 +1,19 @@
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
wrapperVersion=3.3.2
distributionType=only-script
distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.9.9/apache-maven-3.9.9-bin.zip
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/mvnw
New file
@@ -0,0 +1,259 @@
#!/bin/sh
# ----------------------------------------------------------------------------
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------
# Apache Maven Wrapper startup batch script, version 3.3.2
#
# Optional ENV vars
# -----------------
#   JAVA_HOME - location of a JDK home dir, required when download maven via java source
#   MVNW_REPOURL - repo url base for downloading maven distribution
#   MVNW_USERNAME/MVNW_PASSWORD - user and password for downloading maven
#   MVNW_VERBOSE - true: enable verbose log; debug: trace the mvnw script; others: silence the output
# ----------------------------------------------------------------------------
set -euf
[ "${MVNW_VERBOSE-}" != debug ] || set -x
# OS specific support.
native_path() { printf %s\\n "$1"; }
case "$(uname)" in
CYGWIN* | MINGW*)
  [ -z "${JAVA_HOME-}" ] || JAVA_HOME="$(cygpath --unix "$JAVA_HOME")"
  native_path() { cygpath --path --windows "$1"; }
  ;;
esac
# set JAVACMD and JAVACCMD
set_java_home() {
  # For Cygwin and MinGW, ensure paths are in Unix format before anything is touched
  if [ -n "${JAVA_HOME-}" ]; then
    if [ -x "$JAVA_HOME/jre/sh/java" ]; then
      # IBM's JDK on AIX uses strange locations for the executables
      JAVACMD="$JAVA_HOME/jre/sh/java"
      JAVACCMD="$JAVA_HOME/jre/sh/javac"
    else
      JAVACMD="$JAVA_HOME/bin/java"
      JAVACCMD="$JAVA_HOME/bin/javac"
      if [ ! -x "$JAVACMD" ] || [ ! -x "$JAVACCMD" ]; then
        echo "The JAVA_HOME environment variable is not defined correctly, so mvnw cannot run." >&2
        echo "JAVA_HOME is set to \"$JAVA_HOME\", but \"\$JAVA_HOME/bin/java\" or \"\$JAVA_HOME/bin/javac\" does not exist." >&2
        return 1
      fi
    fi
  else
    JAVACMD="$(
      'set' +e
      'unset' -f command 2>/dev/null
      'command' -v java
    )" || :
    JAVACCMD="$(
      'set' +e
      'unset' -f command 2>/dev/null
      'command' -v javac
    )" || :
    if [ ! -x "${JAVACMD-}" ] || [ ! -x "${JAVACCMD-}" ]; then
      echo "The java/javac command does not exist in PATH nor is JAVA_HOME set, so mvnw cannot run." >&2
      return 1
    fi
  fi
}
# hash string like Java String::hashCode
hash_string() {
  str="${1:-}" h=0
  while [ -n "$str" ]; do
    char="${str%"${str#?}"}"
    h=$(((h * 31 + $(LC_CTYPE=C printf %d "'$char")) % 4294967296))
    str="${str#?}"
  done
  printf %x\\n $h
}
verbose() { :; }
[ "${MVNW_VERBOSE-}" != true ] || verbose() { printf %s\\n "${1-}"; }
die() {
  printf %s\\n "$1" >&2
  exit 1
}
trim() {
  # MWRAPPER-139:
  #   Trims trailing and leading whitespace, carriage returns, tabs, and linefeeds.
  #   Needed for removing poorly interpreted newline sequences when running in more
  #   exotic environments such as mingw bash on Windows.
  printf "%s" "${1}" | tr -d '[:space:]'
}
# parse distributionUrl and optional distributionSha256Sum, requires .mvn/wrapper/maven-wrapper.properties
while IFS="=" read -r key value; do
  case "${key-}" in
  distributionUrl) distributionUrl=$(trim "${value-}") ;;
  distributionSha256Sum) distributionSha256Sum=$(trim "${value-}") ;;
  esac
done <"${0%/*}/.mvn/wrapper/maven-wrapper.properties"
[ -n "${distributionUrl-}" ] || die "cannot read distributionUrl property in ${0%/*}/.mvn/wrapper/maven-wrapper.properties"
case "${distributionUrl##*/}" in
maven-mvnd-*bin.*)
  MVN_CMD=mvnd.sh _MVNW_REPO_PATTERN=/maven/mvnd/
  case "${PROCESSOR_ARCHITECTURE-}${PROCESSOR_ARCHITEW6432-}:$(uname -a)" in
  *AMD64:CYGWIN* | *AMD64:MINGW*) distributionPlatform=windows-amd64 ;;
  :Darwin*x86_64) distributionPlatform=darwin-amd64 ;;
  :Darwin*arm64) distributionPlatform=darwin-aarch64 ;;
  :Linux*x86_64*) distributionPlatform=linux-amd64 ;;
  *)
    echo "Cannot detect native platform for mvnd on $(uname)-$(uname -m), use pure java version" >&2
    distributionPlatform=linux-amd64
    ;;
  esac
  distributionUrl="${distributionUrl%-bin.*}-$distributionPlatform.zip"
  ;;
maven-mvnd-*) MVN_CMD=mvnd.sh _MVNW_REPO_PATTERN=/maven/mvnd/ ;;
*) MVN_CMD="mvn${0##*/mvnw}" _MVNW_REPO_PATTERN=/org/apache/maven/ ;;
esac
# apply MVNW_REPOURL and calculate MAVEN_HOME
# maven home pattern: ~/.m2/wrapper/dists/{apache-maven-<version>,maven-mvnd-<version>-<platform>}/<hash>
[ -z "${MVNW_REPOURL-}" ] || distributionUrl="$MVNW_REPOURL$_MVNW_REPO_PATTERN${distributionUrl#*"$_MVNW_REPO_PATTERN"}"
distributionUrlName="${distributionUrl##*/}"
distributionUrlNameMain="${distributionUrlName%.*}"
distributionUrlNameMain="${distributionUrlNameMain%-bin}"
MAVEN_USER_HOME="${MAVEN_USER_HOME:-${HOME}/.m2}"
MAVEN_HOME="${MAVEN_USER_HOME}/wrapper/dists/${distributionUrlNameMain-}/$(hash_string "$distributionUrl")"
exec_maven() {
  unset MVNW_VERBOSE MVNW_USERNAME MVNW_PASSWORD MVNW_REPOURL || :
  exec "$MAVEN_HOME/bin/$MVN_CMD" "$@" || die "cannot exec $MAVEN_HOME/bin/$MVN_CMD"
}
if [ -d "$MAVEN_HOME" ]; then
  verbose "found existing MAVEN_HOME at $MAVEN_HOME"
  exec_maven "$@"
fi
case "${distributionUrl-}" in
*?-bin.zip | *?maven-mvnd-?*-?*.zip) ;;
*) die "distributionUrl is not valid, must match *-bin.zip or maven-mvnd-*.zip, but found '${distributionUrl-}'" ;;
esac
# prepare tmp dir
if TMP_DOWNLOAD_DIR="$(mktemp -d)" && [ -d "$TMP_DOWNLOAD_DIR" ]; then
  clean() { rm -rf -- "$TMP_DOWNLOAD_DIR"; }
  trap clean HUP INT TERM EXIT
else
  die "cannot create temp dir"
fi
mkdir -p -- "${MAVEN_HOME%/*}"
# Download and Install Apache Maven
verbose "Couldn't find MAVEN_HOME, downloading and installing it ..."
verbose "Downloading from: $distributionUrl"
verbose "Downloading to: $TMP_DOWNLOAD_DIR/$distributionUrlName"
# select .zip or .tar.gz
if ! command -v unzip >/dev/null; then
  distributionUrl="${distributionUrl%.zip}.tar.gz"
  distributionUrlName="${distributionUrl##*/}"
fi
# verbose opt
__MVNW_QUIET_WGET=--quiet __MVNW_QUIET_CURL=--silent __MVNW_QUIET_UNZIP=-q __MVNW_QUIET_TAR=''
[ "${MVNW_VERBOSE-}" != true ] || __MVNW_QUIET_WGET='' __MVNW_QUIET_CURL='' __MVNW_QUIET_UNZIP='' __MVNW_QUIET_TAR=v
# normalize http auth
case "${MVNW_PASSWORD:+has-password}" in
'') MVNW_USERNAME='' MVNW_PASSWORD='' ;;
has-password) [ -n "${MVNW_USERNAME-}" ] || MVNW_USERNAME='' MVNW_PASSWORD='' ;;
esac
if [ -z "${MVNW_USERNAME-}" ] && command -v wget >/dev/null; then
  verbose "Found wget ... using wget"
  wget ${__MVNW_QUIET_WGET:+"$__MVNW_QUIET_WGET"} "$distributionUrl" -O "$TMP_DOWNLOAD_DIR/$distributionUrlName" || die "wget: Failed to fetch $distributionUrl"
elif [ -z "${MVNW_USERNAME-}" ] && command -v curl >/dev/null; then
  verbose "Found curl ... using curl"
  curl ${__MVNW_QUIET_CURL:+"$__MVNW_QUIET_CURL"} -f -L -o "$TMP_DOWNLOAD_DIR/$distributionUrlName" "$distributionUrl" || die "curl: Failed to fetch $distributionUrl"
elif set_java_home; then
  verbose "Falling back to use Java to download"
  javaSource="$TMP_DOWNLOAD_DIR/Downloader.java"
  targetZip="$TMP_DOWNLOAD_DIR/$distributionUrlName"
  cat >"$javaSource" <<-END
    public class Downloader extends java.net.Authenticator
    {
      protected java.net.PasswordAuthentication getPasswordAuthentication()
      {
        return new java.net.PasswordAuthentication( System.getenv( "MVNW_USERNAME" ), System.getenv( "MVNW_PASSWORD" ).toCharArray() );
      }
      public static void main( String[] args ) throws Exception
      {
        setDefault( new Downloader() );
        java.nio.file.Files.copy( java.net.URI.create( args[0] ).toURL().openStream(), java.nio.file.Paths.get( args[1] ).toAbsolutePath().normalize() );
      }
    }
    END
  # For Cygwin/MinGW, switch paths to Windows format before running javac and java
  verbose " - Compiling Downloader.java ..."
  "$(native_path "$JAVACCMD")" "$(native_path "$javaSource")" || die "Failed to compile Downloader.java"
  verbose " - Running Downloader.java ..."
  "$(native_path "$JAVACMD")" -cp "$(native_path "$TMP_DOWNLOAD_DIR")" Downloader "$distributionUrl" "$(native_path "$targetZip")"
fi
# If specified, validate the SHA-256 sum of the Maven distribution zip file
if [ -n "${distributionSha256Sum-}" ]; then
  distributionSha256Result=false
  if [ "$MVN_CMD" = mvnd.sh ]; then
    echo "Checksum validation is not supported for maven-mvnd." >&2
    echo "Please disable validation by removing 'distributionSha256Sum' from your maven-wrapper.properties." >&2
    exit 1
  elif command -v sha256sum >/dev/null; then
    if echo "$distributionSha256Sum  $TMP_DOWNLOAD_DIR/$distributionUrlName" | sha256sum -c >/dev/null 2>&1; then
      distributionSha256Result=true
    fi
  elif command -v shasum >/dev/null; then
    if echo "$distributionSha256Sum  $TMP_DOWNLOAD_DIR/$distributionUrlName" | shasum -a 256 -c >/dev/null 2>&1; then
      distributionSha256Result=true
    fi
  else
    echo "Checksum validation was requested but neither 'sha256sum' or 'shasum' are available." >&2
    echo "Please install either command, or disable validation by removing 'distributionSha256Sum' from your maven-wrapper.properties." >&2
    exit 1
  fi
  if [ $distributionSha256Result = false ]; then
    echo "Error: Failed to validate Maven distribution SHA-256, your Maven distribution might be compromised." >&2
    echo "If you updated your Maven version, you need to update the specified distributionSha256Sum property." >&2
    exit 1
  fi
fi
# unzip and move
if command -v unzip >/dev/null; then
  unzip ${__MVNW_QUIET_UNZIP:+"$__MVNW_QUIET_UNZIP"} "$TMP_DOWNLOAD_DIR/$distributionUrlName" -d "$TMP_DOWNLOAD_DIR" || die "failed to unzip"
else
  tar xzf${__MVNW_QUIET_TAR:+"$__MVNW_QUIET_TAR"} "$TMP_DOWNLOAD_DIR/$distributionUrlName" -C "$TMP_DOWNLOAD_DIR" || die "failed to untar"
fi
printf %s\\n "$distributionUrl" >"$TMP_DOWNLOAD_DIR/$distributionUrlNameMain/mvnw.url"
mv -- "$TMP_DOWNLOAD_DIR/$distributionUrlNameMain" "$MAVEN_HOME" || [ -d "$MAVEN_HOME" ] || die "fail to move MAVEN_HOME"
clean || :
exec_maven "$@"
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/mvnw.cmd
New file
@@ -0,0 +1,149 @@
<# : batch portion
@REM ----------------------------------------------------------------------------
@REM Licensed to the Apache Software Foundation (ASF) under one
@REM or more contributor license agreements.  See the NOTICE file
@REM distributed with this work for additional information
@REM regarding copyright ownership.  The ASF licenses this file
@REM to you under the Apache License, Version 2.0 (the
@REM "License"); you may not use this file except in compliance
@REM with the License.  You may obtain a copy of the License at
@REM
@REM    http://www.apache.org/licenses/LICENSE-2.0
@REM
@REM Unless required by applicable law or agreed to in writing,
@REM software distributed under the License is distributed on an
@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
@REM KIND, either express or implied.  See the License for the
@REM specific language governing permissions and limitations
@REM under the License.
@REM ----------------------------------------------------------------------------
@REM ----------------------------------------------------------------------------
@REM Apache Maven Wrapper startup batch script, version 3.3.2
@REM
@REM Optional ENV vars
@REM   MVNW_REPOURL - repo url base for downloading maven distribution
@REM   MVNW_USERNAME/MVNW_PASSWORD - user and password for downloading maven
@REM   MVNW_VERBOSE - true: enable verbose log; others: silence the output
@REM ----------------------------------------------------------------------------
@IF "%__MVNW_ARG0_NAME__%"=="" (SET __MVNW_ARG0_NAME__=%~nx0)
@SET __MVNW_CMD__=
@SET __MVNW_ERROR__=
@SET __MVNW_PSMODULEP_SAVE=%PSModulePath%
@SET PSModulePath=
@FOR /F "usebackq tokens=1* delims==" %%A IN (`powershell -noprofile "& {$scriptDir='%~dp0'; $script='%__MVNW_ARG0_NAME__%'; icm -ScriptBlock ([Scriptblock]::Create((Get-Content -Raw '%~f0'))) -NoNewScope}"`) DO @(
  IF "%%A"=="MVN_CMD" (set __MVNW_CMD__=%%B) ELSE IF "%%B"=="" (echo %%A) ELSE (echo %%A=%%B)
)
@SET PSModulePath=%__MVNW_PSMODULEP_SAVE%
@SET __MVNW_PSMODULEP_SAVE=
@SET __MVNW_ARG0_NAME__=
@SET MVNW_USERNAME=
@SET MVNW_PASSWORD=
@IF NOT "%__MVNW_CMD__%"=="" (%__MVNW_CMD__% %*)
@echo Cannot start maven from wrapper >&2 && exit /b 1
@GOTO :EOF
: end batch / begin powershell #>
$ErrorActionPreference = "Stop"
if ($env:MVNW_VERBOSE -eq "true") {
  $VerbosePreference = "Continue"
}
# calculate distributionUrl, requires .mvn/wrapper/maven-wrapper.properties
$distributionUrl = (Get-Content -Raw "$scriptDir/.mvn/wrapper/maven-wrapper.properties" | ConvertFrom-StringData).distributionUrl
if (!$distributionUrl) {
  Write-Error "cannot read distributionUrl property in $scriptDir/.mvn/wrapper/maven-wrapper.properties"
}
switch -wildcard -casesensitive ( $($distributionUrl -replace '^.*/','') ) {
  "maven-mvnd-*" {
    $USE_MVND = $true
    $distributionUrl = $distributionUrl -replace '-bin\.[^.]*$',"-windows-amd64.zip"
    $MVN_CMD = "mvnd.cmd"
    break
  }
  default {
    $USE_MVND = $false
    $MVN_CMD = $script -replace '^mvnw','mvn'
    break
  }
}
# apply MVNW_REPOURL and calculate MAVEN_HOME
# maven home pattern: ~/.m2/wrapper/dists/{apache-maven-<version>,maven-mvnd-<version>-<platform>}/<hash>
if ($env:MVNW_REPOURL) {
  $MVNW_REPO_PATTERN = if ($USE_MVND) { "/org/apache/maven/" } else { "/maven/mvnd/" }
  $distributionUrl = "$env:MVNW_REPOURL$MVNW_REPO_PATTERN$($distributionUrl -replace '^.*'+$MVNW_REPO_PATTERN,'')"
}
$distributionUrlName = $distributionUrl -replace '^.*/',''
$distributionUrlNameMain = $distributionUrlName -replace '\.[^.]*$','' -replace '-bin$',''
$MAVEN_HOME_PARENT = "$HOME/.m2/wrapper/dists/$distributionUrlNameMain"
if ($env:MAVEN_USER_HOME) {
  $MAVEN_HOME_PARENT = "$env:MAVEN_USER_HOME/wrapper/dists/$distributionUrlNameMain"
}
$MAVEN_HOME_NAME = ([System.Security.Cryptography.MD5]::Create().ComputeHash([byte[]][char[]]$distributionUrl) | ForEach-Object {$_.ToString("x2")}) -join ''
$MAVEN_HOME = "$MAVEN_HOME_PARENT/$MAVEN_HOME_NAME"
if (Test-Path -Path "$MAVEN_HOME" -PathType Container) {
  Write-Verbose "found existing MAVEN_HOME at $MAVEN_HOME"
  Write-Output "MVN_CMD=$MAVEN_HOME/bin/$MVN_CMD"
  exit $?
}
if (! $distributionUrlNameMain -or ($distributionUrlName -eq $distributionUrlNameMain)) {
  Write-Error "distributionUrl is not valid, must end with *-bin.zip, but found $distributionUrl"
}
# prepare tmp dir
$TMP_DOWNLOAD_DIR_HOLDER = New-TemporaryFile
$TMP_DOWNLOAD_DIR = New-Item -Itemtype Directory -Path "$TMP_DOWNLOAD_DIR_HOLDER.dir"
$TMP_DOWNLOAD_DIR_HOLDER.Delete() | Out-Null
trap {
  if ($TMP_DOWNLOAD_DIR.Exists) {
    try { Remove-Item $TMP_DOWNLOAD_DIR -Recurse -Force | Out-Null }
    catch { Write-Warning "Cannot remove $TMP_DOWNLOAD_DIR" }
  }
}
New-Item -Itemtype Directory -Path "$MAVEN_HOME_PARENT" -Force | Out-Null
# Download and Install Apache Maven
Write-Verbose "Couldn't find MAVEN_HOME, downloading and installing it ..."
Write-Verbose "Downloading from: $distributionUrl"
Write-Verbose "Downloading to: $TMP_DOWNLOAD_DIR/$distributionUrlName"
$webclient = New-Object System.Net.WebClient
if ($env:MVNW_USERNAME -and $env:MVNW_PASSWORD) {
  $webclient.Credentials = New-Object System.Net.NetworkCredential($env:MVNW_USERNAME, $env:MVNW_PASSWORD)
}
[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12
$webclient.DownloadFile($distributionUrl, "$TMP_DOWNLOAD_DIR/$distributionUrlName") | Out-Null
# If specified, validate the SHA-256 sum of the Maven distribution zip file
$distributionSha256Sum = (Get-Content -Raw "$scriptDir/.mvn/wrapper/maven-wrapper.properties" | ConvertFrom-StringData).distributionSha256Sum
if ($distributionSha256Sum) {
  if ($USE_MVND) {
    Write-Error "Checksum validation is not supported for maven-mvnd. `nPlease disable validation by removing 'distributionSha256Sum' from your maven-wrapper.properties."
  }
  Import-Module $PSHOME\Modules\Microsoft.PowerShell.Utility -Function Get-FileHash
  if ((Get-FileHash "$TMP_DOWNLOAD_DIR/$distributionUrlName" -Algorithm SHA256).Hash.ToLower() -ne $distributionSha256Sum) {
    Write-Error "Error: Failed to validate Maven distribution SHA-256, your Maven distribution might be compromised. If you updated your Maven version, you need to update the specified distributionSha256Sum property."
  }
}
# unzip and move
Expand-Archive "$TMP_DOWNLOAD_DIR/$distributionUrlName" -DestinationPath "$TMP_DOWNLOAD_DIR" | Out-Null
Rename-Item -Path "$TMP_DOWNLOAD_DIR/$distributionUrlNameMain" -NewName $MAVEN_HOME_NAME | Out-Null
try {
  Move-Item -Path "$TMP_DOWNLOAD_DIR/$MAVEN_HOME_NAME" -Destination $MAVEN_HOME_PARENT | Out-Null
} catch {
  if (! (Test-Path -Path "$MAVEN_HOME" -PathType Container)) {
    Write-Error "fail to move MAVEN_HOME"
  }
} finally {
  try { Remove-Item $TMP_DOWNLOAD_DIR -Recurse -Force | Out-Null }
  catch { Write-Warning "Cannot remove $TMP_DOWNLOAD_DIR" }
}
Write-Output "MVN_CMD=$MAVEN_HOME/bin/$MVN_CMD"
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/pom.xml
New file
@@ -0,0 +1,175 @@
<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <artifactId>pipIrr-mw</artifactId>
        <groupId>com.dy</groupId>
        <version>1.0.0</version>
        <relativePath>../pom.xml</relativePath>
    </parent>
    <packaging>jar</packaging>
    <artifactId>pipIrr-com-creator</artifactId>
    <version>1.0.0</version>
    <name>pipIrr-com-creator</name>
    <description>协议命令生成器</description>
    <dependencies>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-web</artifactId>
            <exclusions>
                <exclusion>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-starter-json</artifactId>
                </exclusion>
                <exclusion>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-starter-logging</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <!-- 动态加载新编译的类 -->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-devtools</artifactId>
            <scope>runtime</scope>
        </dependency>
        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-api</artifactId>
            <version>2.0.7</version>
        </dependency>
        <!-- 测试 -->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-test</artifactId>
            <scope>test</scope>
        </dependency>
    </dependencies>
    <build>
        <plugins>
            <!-- 生成不包含依赖jar的可执行jar包
            <plugin>
                !- spring boot提供的maven打包插件 -
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
                <executions>
                    <execution>
                        !-
                        <goals>
                            <goal>repackage</goal>
                        </goals>
                        -
                        <configuration>
                            !- 不加的话最终包名为: ${artifactId}-${version}.jar, 加了的话最终包名: ${artifactId}-${version}-${classifier}.jar  -
                            <classifier>execute</classifier>
                            !- 不指定生成路径的话, 默认保存在 ${build.directory} 下 -
                            <outputDirectory>${project.build.directory}/execute</outputDirectory>
                            <finalName>${artifactId}-${version}</finalName>
                            <layout>ZIP</layout>
                            <mainClass>com.dy.pipIrrBase.PipIrrBaseApplication</mainClass>
                            <includes>
                                <include>
                                    <groupId>com.dy</groupId>
                                    <artifactId>pipIrr-common</artifactId>
                                </include>
                                <include>
                                    <groupId>com.dy</groupId>
                                    <artifactId>pipIrr-global</artifactId>
                                </include>
                            </includes>
                            <excludes>
                                <exclude>
                                    <groupId>org.projectlombok</groupId>
                                    <artifactId>lombok</artifactId>
                                </exclude>
                            </excludes>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            -->
            <!-- 拷贝依赖的jar包到lib目录-->
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
                <executions>
                    <execution>
                        <configuration>
                            <!-- 不加的话最终包名为: ${artifactId}-${version}.jar, 加了的话最终包名: ${artifactId}-${version}-${classifier}.jar
                            <classifier>execute</classifier>
                            -->
                            <!-- ${project.build.directory}是maven变量,内置的,表示target目录,如果不写,将在根目录下创建/lib -->
                            <outputDirectory>${project.build.directory}/lib</outputDirectory>
                            <!-- excludeTransitive:是否不包含间接依赖包,比如我们依赖A,但是A又依赖了B,我们是否也要把B打进去 默认不打-->
                            <excludeTransitive>false</excludeTransitive>
                            <!-- 复制的jar文件去掉版本信息 -->
                            <stripVersion>false</stripVersion>
                            <finalName>${project.artifactId}-${project.version}</finalName>
                            <layout>ZIP</layout>
                            <mainClass>com.dy.rtuMw.PipIrrMwAcceptApplication</mainClass>
                            <includes>
                                <include>
                                    <groupId>com.dy</groupId>
                                    <artifactId>pipIrr-common</artifactId>
                                </include>
                                <include>
                                    <groupId>com.dy</groupId>
                                    <artifactId>pipIrr-global</artifactId>
                                </include>
                            </includes>
                            <excludes>
                                <exclude>
                                    <groupId>org.projectlombok</groupId>
                                    <artifactId>lombok</artifactId>
                                </exclude>
                            </excludes>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <!-- 设置java编译版本,运行环境版本 -->
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <!-- source: 源代码编译版本;target: 目标平台编译版本;encoding: 字符集编码。 -->
                <configuration>
                    <source>${java.version}</source>
                    <target>${java.version}</target>
                    <encoding>${encoding}</encoding>
                </configuration>
            </plugin>
            <plugin>
                <!-- 解决资源文件的编码问题 -->
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-resources-plugin</artifactId>
                <configuration>
                    <encoding>${encoding}</encoding>
                </configuration>
            </plugin>
            <plugin>
                <!-- maven里执行测试用例的插件 -->
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <configuration>
                    <skipTests>true</skipTests>
                </configuration>
            </plugin>
            <plugin>
                <!-- 下面解决:当进行Maven Lifecycle package时报错:Could not find artifact org.apache.mina:mina-core:bundle:2.2.1 in maven (https://repo1.maven.org/maven2/)-->
                <groupId>org.apache.felix</groupId>
                <artifactId>maven-bundle-plugin</artifactId>
                <extensions>true</extensions>
            </plugin>
        </plugins>
    </build>
</project>
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/PipIrrComCreatorApplication.java
New file
@@ -0,0 +1,166 @@
package com.dy.pipirrComCreator;
import com.dy.common.mw.protocol.p206V1.ProtocolConstantV206V1;
import com.dy.common.util.NumUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.WebApplicationType;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.FilterType;
@Slf4j
@SpringBootApplication(exclude = {DataSourceAutoConfiguration.class}) //禁止启动数据库连接池
@ComponentScan(basePackages = {"com.dy.common", "com.dy.pipIrrGlobal", "com.dy.pipirrComCreator"},
        excludeFilters = {
                @ComponentScan.Filter(type = FilterType.ASSIGNABLE_TYPE, classes = {
                        com.dy.common.apiDoc.SpringApiConfig.class, //一种排除类的方式
                        com.dy.pipIrrGlobal.config.DingTalk.class
                }),
                @ComponentScan.Filter(type = FilterType.REGEX, pattern = {
                        //二种排除类的方式,写正则表达式,需要对目标类的完全限定名完全匹配,否则不生效
                        "com.dy.common.aop..*",
                        "com.dy.common.apiDoc..*",
                        "com.dy.common.multiDataSource..*",
                        "com.dy.common.singleDataSource..*",
                        "com.dy.common.mybatis..*",
                        "com.dy.common.webFilter..*",
                        "com.dy.common.webListener..*",
                        "com.dy.pipIrrGlobal.config..*",
                        "com.dy.pipIrrGlobal.webCtrls..*"
                })
        }
)
public class PipIrrComCreatorApplication implements CommandLineRunner {
    /**
     * 参数0:协议名称(当前只支持p206V1)
     * 参数1:协议版本号(当前只支持1)
     * 参数2:rtu地址
     * 参数3:IC卡地址
     * 参数4:IC卡编号
     * @param args
     */
    public static void main(String[] args) {
        int index = 0 ;
        parseArg0(args, index++) ;
        parseArg1(args, index++) ;
        parseArg2(args, index++) ;
        parseArg3(args, index++) ;
        parseArg4(args, index++) ;
        new SpringApplicationBuilder(PipIrrComCreatorApplication.class)
                .web(WebApplicationType.NONE)//不启动web服务
                .run(args);
    }
    private static void parseArg0(String[] args, int index){
        if(args != null
                && args.length > index
                && args[index] != null
                && !args[index].trim().equals("")){
            ServerProperties.protocolName = args[index] ;//协议名称
            log.info("参数" + (index + 1) + ":" + ServerProperties.protocolName);
        }
        if(ServerProperties.protocolName == null || ServerProperties.protocolName.trim().equals("")){
            ServerProperties.protocolName = ProtocolConstantV206V1.protocolName ;
            ServerProperties.protocolVersion = ProtocolConstantV206V1.protocolVer ;
        }
    }
    private static void parseArg1(String[] args, int index){
        if(args != null
                && args.length > index
                && args[index] != null
                && !args[index].trim().equals("")){
            if(ServerProperties.protocolVersion == -1){
                if(NumUtil.isPlusIntNumber(args[index].trim())){
                    ServerProperties.protocolVersion = Short.parseShort(args[index].trim()) ;//协议版本号
                }
            }
            log.info("参数" + (index + 1) + ":" + args[index].trim());
        }else{
            if(ServerProperties.protocolVersion == -1){
                ServerProperties.protocolVersion = ProtocolConstantV206V1.protocolVer ;
            }
        }
    }
    private static void parseArg2(String[] args, int index){
        if(args != null
                && args.length > index
                && args[index] != null
                && !args[index].trim().equals("")){
            ServerProperties.rtuAddr = args[index] ;//本模拟器模拟RTU地址
            log.info("参数" + (index + 1) + ":" + ServerProperties.rtuAddr);
        }
        if(ServerProperties.rtuAddr == null){
            ServerProperties.rtuAddr = "37142501020100218" ;
        }
    }
    private static void parseArg3(String[] args, int index){
        if(args != null
                && args.length > index
                && args[index] != null
                && !args[index].trim().equals("")){
            ServerProperties.icCardAddr = args[index] ;//IC卡地址
            log.info("参数" + (index + 1) + ":" + ServerProperties.icCardAddr);
        }
        if(ServerProperties.icCardAddr == null){
            ServerProperties.icCardAddr = "C49A340D" ;
        }
    }
    private static void parseArg4(String[] args, int index){
        if(args != null
                && args.length > index
                && args[index] != null
                && !args[index].trim().equals("")){
            ServerProperties.icCardNo = args[index] ;//IC卡编号
            log.info("参数" + (index + 1) + ":" + ServerProperties.icCardNo);
        }
        if(ServerProperties.icCardNo == null){
            ServerProperties.icCardNo = "37142501020100257" ;
        }
    }
    /**
     * Spring容器启动完成后,执行下面方法
     * @param args 参数
     * @throws Exception 异常
     */
    @Override
    public void run(String... args) throws Exception {
        try{
            //等待一下
            Thread.sleep(500L);
        }catch (Exception e){
            e.printStackTrace();
        }
        finally {
            this.startMwSv() ;
        }
    }
    private void startMwSv(){
        if(sv != null){
            try {
                sv.startServer();
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }
    private Server sv ;
    @Autowired
    public void setSv(Server sv){
        this.sv = sv ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/Server.java
New file
@@ -0,0 +1,27 @@
package com.dy.pipirrComCreator;
import com.dy.pipirrComCreator.console.CommandConsole;
import org.springframework.stereotype.Component;
import java.io.Console;
/**
 * @Author: liurunyu
 * @Date: 2025/5/6 18:02
 * @Description
 */
@Component
public class Server {
    public void startServer() throws Exception{
        Console console = System.console();
        if (console == null) {
            throw new Exception("严重错误,未能得到控制台对象!");
        }
        CommandConsole mwConsole = new CommandConsole(console) ;
        mwConsole.init();
        boolean exit = mwConsole.clientConsole() ;
        if(exit){
            System.exit(-1);
        }
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/ServerProperties.java
New file
@@ -0,0 +1,16 @@
package com.dy.pipirrComCreator;
/**
 * @Author: liurunyu
 * @Date: 2025/02/26 11:03
 * @Description
 */
public class ServerProperties {
    public static String protocolName ;//协议名称
    public static short protocolVersion = -1 ;//协议版本
    public static String rtuAddr ;//RTU地址
    public static String icCardAddr ;//IC卡地址
    public static String icCardNo ;//IC卡编号
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/console/Command.java
New file
@@ -0,0 +1,185 @@
package com.dy.pipirrComCreator.console;
import com.dy.common.mw.protocol.p206V1.CodeV1;
import com.dy.common.mw.protocol.p206V1.ProtocolConstantV206V1;
import com.dy.pipirrComCreator.ServerProperties;
import com.dy.pipirrComCreator.p206V1.Cd02;
import com.dy.pipirrComCreator.p206V1.Cd10;
import com.dy.pipirrComCreator.p206V1.Cd92;
import com.dy.pipirrComCreator.p206V1.Cd93;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
public class Command {
    private static String[] commands ;
    static{
        commands = new String[]{
                "config 查看配置信息",
                "XY ... 协议命令",
                "exit 退出",
        };
    }
    public static boolean dealCommand(String command, PrintWriter prtWrt) throws Exception{
        boolean exit = false ;
        command = command.trim() ;
        if (command.equals("help")) {
            outHelp(prtWrt);
        }else if (command.equals("config")) {
            outConfig(prtWrt);
        }else if(command.equals("exit")){
            exit = true ;
        }else if(isProtocolCom(command)){
            dealProtocolCom(command, prtWrt);
        }else {
            outNoIdentify(prtWrt);
        }
        return exit ;
    }
    private static boolean isProtocolCom(String command){
        if(ServerProperties.protocolName.equals(ProtocolConstantV206V1.protocolName)){
            String[] coms = command.split(" ");
            for (String com : coms){
                if(!com.equals("")){
                    if(CodeV1.isValid(com)){
                        return true ;
                    }else{
                        return false ;
                    }
                }
            }
        }
        return false ;
    }
    private static void dealProtocolCom(String command, PrintWriter prtWrt) throws Exception{
        String[] coms = command.split(" ");
        List<String> comList = new ArrayList<>();
        for (String com : coms){
            if(!com.equals("")){
                comList.add(com) ;
            }
        }
        String com = comList.get(0) ;
        switch (com) {
            case CodeV1.cd_02: cd02(comList, prtWrt); break;
            case CodeV1.cd_10: cd10(comList, prtWrt); break;
            case CodeV1.cd_92: cd92(comList, prtWrt); break;
            case CodeV1.cd_93: cd93(comList, prtWrt); break;
            default: outNoIdentify(prtWrt); break;
        }
    }
    private static void cd02(List<String> comList, PrintWriter prtWrt)throws Exception{
        if(comList.size() > 1){
            String p = comList.get(1);
            if(p.equals("-h")){
                prtWrt.println("02[Enter](心跳命令应答(链路维持报应答))");
            }else{
                outNoIdentify(prtWrt) ;
            }
        }else{
            out(new Cd02().hex(ServerProperties.rtuAddr), prtWrt);
        }
    }
    private static void cd10(List<String> comList, PrintWriter prtWrt)throws Exception{
        if(comList.size() > 1){
            String p1 = comList.get(1);
            if(p1.equals("-h")){
                prtWrt.println("10 *...*[Enter](设置控制器地址)");
            }else{
                String[] ps = params2Grp(comList) ;
                Cd10 cd = new Cd10() ;
                String msg = cd.checkParams(ps) ;
                if(msg == null){
                    out(new Cd10().hex(ServerProperties.rtuAddr, ps), prtWrt);
                }else{
                    out(msg, prtWrt);
                }
            }
        }else{
            outNoParams(prtWrt); ;
        }
    }
    private static void cd92(List<String> comList, PrintWriter prtWrt)throws Exception{
        if(comList.size() > 1){
            String p = comList.get(1);
            if(p.equals("-h")){
                prtWrt.println("92[Enter](平台远程开启阀门)");
            }else{
                outNoIdentify(prtWrt) ;
            }
        }else{
            out(new Cd92().hex(ServerProperties.rtuAddr), prtWrt);
        }
    }
    private static void cd93(List<String> comList, PrintWriter prtWrt)throws Exception{
        if(comList.size() > 1){
            String p = comList.get(1);
            if(p.equals("-h")){
                prtWrt.println("93[Enter](平台远程关闭阀门)");
            }else{
                outNoIdentify(prtWrt) ;
            }
        }else{
            out(new Cd93().hex(ServerProperties.rtuAddr), prtWrt);
        }
    }
    private static String[] params2Grp(List<String> comList){
        String[] ps = new String[comList.size()-1] ;
        for(int i = 1; i < comList.size(); i++){
            ps[i-1] = comList.get(i) ;
        }
        return ps ;
    }
    private static void out(String str, PrintWriter prtWrt){
        prtWrt.println(str==null?"":str);
    }
    private static void outHelp(PrintWriter prtWrt){
        prtWrt.println("");
        prtWrt.println("命令");
        for(String s : commands){
            prtWrt.println("  " + s);
        }
        prtWrt.println("");
    }
    private static void outConfig(PrintWriter prtWrt){
        prtWrt.println("");
        prtWrt.println("预先设置");
        prtWrt.println("  协议:" + ServerProperties.protocolName);
        prtWrt.println("  协议版本号:" + ServerProperties.protocolVersion);
        prtWrt.println("  Rtu地址:" + ServerProperties.rtuAddr);
        prtWrt.println("  IC卡地址:" + ServerProperties.icCardAddr);
        prtWrt.println("  IC卡编号:" + ServerProperties.icCardNo);
        prtWrt.println("");
    }
    private static void outNoIdentify(PrintWriter prtWrt){
        prtWrt.println("");
        prtWrt.println("命令不可识别!");
        prtWrt.println("");
    }
    private static void outNoParams(PrintWriter prtWrt){
        prtWrt.println("");
        prtWrt.println("请输入命令参数!");
        prtWrt.println("");
    }
    public static void main(String[] args) {
        String com = "   02 123       345          789";
        com = com.trim() ;
        String[] coms = com.split(" ");
        for(String s : coms){
            System.out.println(s);
        }
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/console/CommandConsole.java
New file
@@ -0,0 +1,89 @@
package com.dy.pipirrComCreator.console;
import lombok.extern.slf4j.Slf4j;
import java.io.Console;
import java.io.PrintWriter;
@Slf4j
public class CommandConsole {
    private Console console ;
    private PrintWriter prtWrt ;
    private static final String myPassword = "123456" ;
    private static final String commandPrefix1 = ">>" ;
    private static final String commandPrefix2 = "$: " ;
    private static String commandPrefix = commandPrefix1 + commandPrefix2 ;
    public CommandConsole(Console console)throws Exception{
        this.console = console ;
        if(this.console == null){
            throw new Exception("严重错误,java控制台对象为空!");
        }
        prtWrt = console.writer() ;
    }
    /**
     * 初始,检查并输出一些信息
     * @throws Exception
     */
    public void init() throws Exception{
        PrintWriter prtWrt = console.writer() ;
        prtWrt.println("----------------------------------------");
        prtWrt.println("--                                    --");
        prtWrt.println("--    欢迎使用命令生成器              --");
        prtWrt.println("--                                    --");
        prtWrt.println("----------------------------------------");
    }
    /**
     * 执行控制台控制
     * @return
     */
    public boolean clientConsole(){
        boolean exit = false ;
        try {
            this.login() ;
            exit = this.doConsole();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return exit ;
    }
    private boolean login(){
        while (true) {
            //String username = console.readLine(">>Username: ");
            char[] password = console.readPassword(">>Password: ");
            String passwordStr = String.valueOf(password) ;
            if (passwordStr.equals("help")) {
                console.printf("密码是%1$s.\n", myPassword);
                // 使用后应立即将数组清空,以减少其在内存中占用的时间,增强安全性
                password = null;
            } else if(passwordStr.equals(myPassword)){
                return true;
            }
        }
    }
    private boolean doConsole(){
        boolean exit = false ;
        while (!exit) {
            String command = console.readLine(commandPrefix);
            try {
                exit = Command.dealCommand(command, prtWrt) ;
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return exit ;
    }
    public static void changeCommandPrefix(String prefix){
        commandPrefix = commandPrefix1 + prefix ;
    }
    public static void recoverCommandPrefix(){
        commandPrefix = commandPrefix1 + commandPrefix2 ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd.java
New file
@@ -0,0 +1,65 @@
package com.dy.pipirrComCreator.p206V1;
import com.dy.common.mw.protocol.p206V1.ProtocolConstantV206V1;
import com.dy.common.mw.protocol.p206V1.parse.global.GlCreate;
import com.dy.common.util.ByteUtil;
/**
 * @Author: liurunyu
 * @Date: 2025/5/7 8:43
 * @Description
 */
public abstract class Cd {
    protected static final byte CTRL = (byte)0xB0 ;//控制域
    public abstract String checkParams(String ...params) ;
    public byte[] createHead(String rtuAddr, String code, byte ctrl)throws Exception {
        byte[] bsHead = new byte[ProtocolConstantV206V1.lenHead2Code] ;
        byte index = 0 ;
        bsHead[index] = ProtocolConstantV206V1.P_Head_Byte ;
        index++ ;
        bsHead[index] = 0 ;//帧长度
        index++ ;
        bsHead[index] = ProtocolConstantV206V1.P_Head_Byte ;
        index++ ;
        bsHead[index] = ctrl; //控制域功能码
        index++ ;
        GlCreate.createRtuAddr4P206(rtuAddr, bsHead, index);
        index += 5 ;
        ByteUtil.hex2Bytes(code, bsHead, index) ;
        return bsHead ;
    }
    public byte[] createHead4Upgrade(String rtuAddr, String preCode, String sufCode)throws Exception {
        byte[] bsHead = new byte[12] ;
        byte index = 0 ;
        bsHead[index] = ProtocolConstantV206V1.UG_P_Head_Byte ;
        index++ ;
        bsHead[index] = 0 ;//帧长度
        index++ ;
        bsHead[index] = 0 ;//帧长度
        index++ ;
        bsHead[index] = ProtocolConstantV206V1.UG_P_Head_Byte ;
        index++ ;
        bsHead[index] = ByteUtil.hex2Bytes(preCode)[0]; //功能码域
        index++ ;
        bsHead[index] = ByteUtil.hex2Bytes(sufCode)[0]; //功能码域
        index++ ;
        GlCreate.createRtuAddr4P206(rtuAddr, bsHead, index);
        return bsHead ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd02.java
New file
@@ -0,0 +1,51 @@
package com.dy.pipirrComCreator.p206V1;
import com.dy.common.mw.protocol.p206V1.parse.global.GlCreate;
import com.dy.common.util.ByteUtil;
/**
 * @Author: liurunyu
 * @Date: 2025/5/7 8:42
 * @Description
 */
public class Cd02 extends Cd {
    public static final String ComCode = "02" ;
    public String checkParams(String ...params){
        return null ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public String hex(String rtuAddr) throws Exception {
        byte[] bytes = bs(rtuAddr) ;
        String hex = ByteUtil.bytes2Hex(bytes, false) ;
        return hex ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public byte[] bs(String rtuAddr) throws Exception {
        byte[] bytes = createHead(rtuAddr, ComCode, Cd.CTRL);
        byte[] bs = new byte[1] ;
        bs[0] = (byte)0xF2 ;//数据域: 1 个字节,F0 登录, F1 退出登录,F2 在线保持。
        bytes = ByteUtil.bytesMerge(bytes, bs) ;
        GlCreate.createLen(bytes);//长度放字节数组中
        byte[] bsTail = GlCreate.createCrcTail4P206(bytes) ;//CRC和尾叠加字节数组中
        bytes = ByteUtil.bytesMerge(bytes, bsTail) ;
        return bytes ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd10.java
New file
@@ -0,0 +1,64 @@
package com.dy.pipirrComCreator.p206V1;
import com.dy.common.mw.protocol.p206V1.parse.global.GlCreate;
import com.dy.common.util.ByteUtil;
import com.dy.common.util.NumUtil;
/**
 * @Author: liurunyu
 * @Date: 2025/5/7 9:30
 * @Description
 */
public class Cd10 extends Cd {
    public static final String ComCode = "10" ;
    public String checkParams(String ...params){
        if(params.length != 1){
            return "只有控制器地址一个参数" ;
        }
        if(!NumUtil.isPlusIntNumber(params[0])){
            return "控制器地址参数必须是正整数" ;
        }
        if(params[0].length() != 12){
            return "控制器地址参数必须是12位数字" ;
        }
        return null ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public String hex(String rtuAddr, String ...params) throws Exception {
        byte[] bytes = bs(rtuAddr, params) ;
        String hex = ByteUtil.bytes2Hex(bytes, false) ;
        return hex ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public byte[] bs(String rtuAddr, String ...params) throws Exception {
        byte[] bytes = createHead(rtuAddr, ComCode, Cd.CTRL);
        byte n = 0;
        byte[] bs = new byte[13];
        GlCreate.createRtuAddr4P206(params[0], bs, n);
        n += 5;
        GlCreate.createPw(bs, n);
        n += 2;
        GlCreate.createTp(bs, n);
        bytes = ByteUtil.bytesMerge(bytes, bs);
        GlCreate.createLen(bytes);//长度放字节数组中
        byte[] bsTail = GlCreate.createCrcTail4P206(bytes) ;//CRC和尾叠加字节数组中
        bytes = ByteUtil.bytesMerge(bytes, bsTail) ;
        return bytes ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd92.java
New file
@@ -0,0 +1,59 @@
package com.dy.pipirrComCreator.p206V1;
import com.dy.common.mw.protocol.p206V1.parse.global.GlCreate;
import com.dy.common.util.ByteUtil;
/**
 * @Author: liurunyu
 * @Date: 2025/5/7 10:36
 * @Description
 */
public class Cd92 extends Cd {
    public static final String ComCode = "92" ;
    /**
     * 检查参数
     * @param params 参数
     * @return 字符串
     */
    public String checkParams(String ...params){
        return null ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public String hex(String rtuAddr) throws Exception {
        byte[] bytes = bs(rtuAddr) ;
        String hex = ByteUtil.bytes2Hex(bytes, false) ;
        return hex ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public byte[] bs(String rtuAddr) throws Exception {
        byte[] bytes = createHead(rtuAddr, ComCode, Cd.CTRL);
        byte n = 0 ;
        byte[] bs = new byte[9] ;
        bs[n++] = (byte)0xF0 ;
        GlCreate.createPw(bs, n);
        n += 2 ;
        GlCreate.createTp(bs, n);
        bytes = ByteUtil.bytesMerge(bytes, bs) ;
        GlCreate.createLen(bytes);//长度放字节数组中
        byte[] bsTail = GlCreate.createCrcTail4P206(bytes) ;//CRC和尾叠加字节数组中
        bytes = ByteUtil.bytesMerge(bytes, bsTail) ;
        return bytes ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/java/com/dy/pipirrComCreator/p206V1/Cd93.java
New file
@@ -0,0 +1,59 @@
package com.dy.pipirrComCreator.p206V1;
import com.dy.common.mw.protocol.p206V1.parse.global.GlCreate;
import com.dy.common.util.ByteUtil;
/**
 * @Author: liurunyu
 * @Date: 2025/5/7 10:38
 * @Description
 */
public class Cd93 extends Cd {
    public static final String ComCode = "93" ;
    /**
     * 检查参数
     * @param params 参数
     * @return 字符串
     */
    public String checkParams(String ...params){
        return null ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public String hex(String rtuAddr) throws Exception {
        byte[] bytes = bs(rtuAddr) ;
        String hex = ByteUtil.bytes2Hex(bytes, false) ;
        return hex ;
    }
    /**
     * 构造心跳数据
     * @return 字节数组
     * @throws Exception 异常
     */
    public byte[] bs(String rtuAddr) throws Exception {
        byte[] bytes = createHead(rtuAddr, ComCode, Cd.CTRL);
        byte n = 0 ;
        byte[] bs = new byte[9] ;
        bs[n++] = (byte)0xF0 ;
        GlCreate.createPw(bs, n);
        n += 2 ;
        GlCreate.createTp(bs, n);
        bytes = ByteUtil.bytesMerge(bytes, bs) ;
        GlCreate.createLen(bytes);//长度放字节数组中
        byte[] bsTail = GlCreate.createCrcTail4P206(bytes) ;//CRC和尾叠加字节数组中
        bytes = ByteUtil.bytesMerge(bytes, bsTail) ;
        return bytes ;
    }
}
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/resources/application.yml
New file
@@ -0,0 +1,18 @@
logging:
    charset:
        console: UTF-8
    config:
        classpath: log4j2.yml
spring:
    devtools:
        livereload:
            enabled: false
#禁输出springboot标志信息
management:
    endpoints:
        info:
            enabled: false
        web:
            exposure:
                include: "*"
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/main/resources/log4j2.xml
New file
@@ -0,0 +1,23 @@
<?xml version="1.0" encoding="UTF-8"?>
<Configuration status="OFF">
  <Appenders>
    <Console name="Console" target="SYSTEM_OUT">
      <PatternLayout charset="UTF-8" pattern="%d %-5p [%t] (%F:%L) - %m%n%throwable"/>
    </Console>
    <RollingFile name="File" fileName="logs/comCreator.log" filePattern="logs/comCreator-%d{yyyyMMdd}-%i.log">
      <PatternLayout charset="UTF-8" pattern="%d %-5p [%t] (%class.%method:%L) - %m%n%throwable"/>
      <Policies>
        <TimeBasedTriggeringPolicy interval="7" />
        <SizeBasedTriggeringPolicy size="10MB"/>
      </Policies>
      <DefaultRolloverStrategy max="50" />
    </RollingFile>
  </Appenders>
  <Loggers>
    <!-- Root与各个Logger同时起作用 -->
    <Root level="error">
      <AppenderRef ref="Console"/>
      <AppenderRef ref="File"/>
    </Root>
  </Loggers>
</Configuration>
pipIrr-platform/pipIrr-mw/pipIrr-com-creator/src/test/java/com/dy/pipirrComCreator/PipIrrComCreatorApplicationTests.java
New file
@@ -0,0 +1,13 @@
package com.dy.pipirrComCreator;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
@SpringBootTest
class PipIrrComCreatorApplicationTests {
    @Test
    void contextLoads() {
    }
}
pipIrr-platform/pipIrr-mw/pom.xml
@@ -21,6 +21,7 @@
        <module>pipIrr-mw-simulate-rtu202404</module>
        <module>pipIrr-mwTest-server</module>
        <module>pipIrr-mwTest-client</module>
        <module>pipIrr-com-creator</module>
    </modules>
    <dependencies>